HDU 5073 Galaxy(贪心)

题目大意:给你n个点,拿走k个之后,让你求出怎么拿使得剩下的inertia最小。

解体思路:贪心的策略。剩下的数只有当连续的时候,值会最小,枚举一遍求出来间距为n-k的最小的inertia。

PS:(x1-d)^2+(x2-d)^2+……+(xn-d)^2 = sum(x1^2+……+xn^2)+n*d*d-2*n(sum(x1+x2+……+xn)).

Galaxy

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others)
Total Submission(s): 2269    Accepted Submission(s): 548
Special Judge


Problem Description
Good news for us: to release the financial pressure, the government started selling galaxies and we can buy them from now on! The first one who bought a galaxy was Tianming Yun and he gave it to Xin Cheng as a present.


To be fashionable, DRD also bought himself a galaxy. He named it Rho Galaxy. There are n stars in Rho Galaxy, and they have the same weight, namely one unit weight, and a negligible volume. They initially lie in a line rotating around their center of mass.

Everything runs well except one thing. DRD thinks that the galaxy rotates too slow. As we know, to increase the angular speed with the same angular momentum, we have to decrease the moment of inertia.

The moment of inertia I of a set of n stars can be calculated with the formula


where w i is the weight of star i, d i is the distance form star i to the mass of center.

As DRD’s friend, ATM, who bought M78 Galaxy, wants to help him. ATM creates some black holes and white holes so that he can transport stars in a negligible time. After transportation, the n stars will also rotate around their new center of mass. Due to financial pressure, ATM can only transport at most k stars. Since volumes of the stars are negligible, two or more stars can be transported to the same position.

Now, you are supposed to calculate the minimum moment of inertia after transportation.
 

Input
The first line contains an integer T (T ≤ 10), denoting the number of the test cases.

For each test case, the first line contains two integers, n(1 ≤ n ≤ 50000) and k(0 ≤ k ≤ n), as mentioned above. The next line contains n integers representing the positions of the stars. The absolute values of positions will be no more than 50000.
 

Output
For each test case, output one real number in one line representing the minimum moment of inertia. Your answer will be considered correct if and only if its absolute or relative error is less than 1e-9.
 

Sample Input
  
  
2 3 2 -1 0 1 4 2 -2 -1 1 2
 

Sample Output
  
  
0 0.5
 

#include <algorithm>
#include <iostream>
#include <stdlib.h>
#include <string.h>
#include <iomanip>
#include <stdio.h>
#include <string>
#include <queue>
#include <cmath>
#include <stack>
#include <ctime>
#include <map>
#include <set>
#define eps 1e-9
///#define M 1000100
///#define LL __int64
#define LL long long
///#define INF 0x7ffffff
#define INF 0x3f3f3f3f
#define PI 3.1415926535898
#define zero(x) ((fabs(x)<eps)?0:x)
#define mod 1000000007

using namespace std;

const int maxn = 50110;

double sum1[maxn], sum2[maxn];
double num[maxn];

int main()
{
    int T;
    cin >>T;
    while(T--)
    {
        int n, k;
        cin >>n>>k;
        for(int i = 1; i <= n; i++) scanf("%lf",&num[i]);
        sort(num+1, num+1+n);
        memset(sum1, 0, sizeof(sum1));
        memset(sum2, 0, sizeof(sum2));
        int m = n-k;
        if(!m)
        {
            printf("0.0000000000\n");
            continue;
        }
        double Min = 1000000000000000000.0;
        for(int i = 1; i <= n; i++)
        {
            sum1[i] = sum1[i-1]+num[i];
            sum2[i] = sum2[i-1]+num[i]*num[i];
        }
        for(int i = 1; i <= n-m+1; i++)
        {
            int x = i;
            int y = i+m-1;
            double d = (sum1[y]-sum1[x-1])/m*1.0;
            double tmp = (sum2[y]-sum2[x-1]) + m*1.0*d*d-2.0*d*(sum1[y]-sum1[x-1]);
            Min = min(Min, tmp);
        }
        printf("%.10lf\n",Min);
    }
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值